/*
 *	The node types for the first byte in any node
 */
define( `nodenum', -1 )
/* macro arguments
 * $1 - name of node
 * $2 - print code
 * $3 - flags for the node
 * $4 - number of tree-type children for the node
 * $5 - number of total children for the node
 */
define(makenode,`divert(9)define(`nodenum',incr(nodenum))
`#define' N_$1 nodenum 
divert(1) {$2, $3, $4, $5},
divert(-1)' )

`#include' "nc.h"
divert(1)struct node_info node_table[] = {
divert(9)
/* BEGIN_DEFINE */
divert(10)

makenode( NULL, "", 0, 0, 0 )
makenode( LIST, "", 0, 0, 0 )
makenode( EXTERN, "extern !0d;", 0, 1, 1 )
makenode( EXT_FUNC, "extern !0d();", 0, 2, 2 )
makenode( DECL_VAR, "!0d;", 0, 1, 1 )
makenode( ID, "!0i", 0, 0, 1 )
makenode( ROUTINE, "!0l\n!1l", 0, 2, 2 )
makenode( LABELED, "!0t : !1t", 0, 2, 2 )
makenode( CASE, "case !0t :\n!1t", 0, 2, 2 )
makenode( DEFAULT, "default:\n!0t", 0, 1, 1 )
makenode( COMPOUND, "{\n!0l\n}", 0, 1, 1 )
makenode( SEMISTAT, "!0t;", 0, 1, 1 )
makenode( ADJUST, "score += (!0t);", 0, 1, 1 )
makenode( CALL, "", 0, 2, 2 )
makenode( ASSIGN, "!0t = !1t", 0, 2, 2 )
makenode( IF, "if( !0t )!>\n!1t!<", 0, 2, 2 )
makenode( IFELSE, "if( !0t )!>\n!1t!<\nelse!>\n!2t!<", TF_ONEINT, 3, 3 )
makenode( SWITCH, "switch( !0t ) !>\n!1t!<", TF_ONEINT, 2, 2 )
makenode( WHILE, "while( !0t )!>\n!1t!<", TF_ONEINT, 2, 2 )
makenode( FOR, "for( !0t; !1t; !2t ) !>\n!3t!<", 0, 4, 4 )
makenode( FOREACH, "", 0, 3, 3 )
makenode( GOTO, "goto !0t;", 0, 1, 1 )
makenode( CONTINUE, "continue;", 0, 0, 0 )
makenode( BREAK, "break;", 0, 0, 0 )
makenode( RETURN, "return !0t;", 0, 1, 1 ) /* special */
makenode( ACCEPT, "return score = Accept;", TF_RET, 0, 0 )
makenode( IFACCEPT, "{if( !0t ) return score = Accept;}", TF_ONEINT|TF_RET, 1, 1 )
makenode( REJECT, "return score = Reject;", TF_RET, 0, 0 )
makenode( IFREJECT, "{if( !0t ) return score = Reject;}", TF_ONEINT|TF_RET, 1, 1 )
makenode( INDEX, "!0t->vals[!1t]", 0, 2, 2 )
makenode( FUNCALL, "!0t(!1,)", 0, 2, 2 )
makenode( INT, "!0N", 0, 0, 1 )
makenode( STRING, "!0$", 0, 0, 1 )
makenode( NGROUP, "!0n", 0, 0, 1 )
makenode( QGROUP, "gquery(!0n)", TF_RETINT, 0, 1 )
makenode( PAREN, "(!0t)", 0, 1, 1 )
makenode( POSTINC, "!0t++", 0, 1, 1 )
makenode( POSTDEC, "!0t--", 0, 1, 1 )
makenode( PREINC, "++!0t", 0, 1, 1 )
makenode( PREDEC, "--!0t", 0, 1, 1 )
makenode( UPLUS, "+!0t", TF_ONEINT, 1, 1, )
makenode( UMINUS, "-!0t", TF_ONEINT, 1, 1 )
makenode( NOT, "!!!0t", TF_ONEINT|TF_RETINT, 1, 1 )
makenode( MULT, "!0t*!1t", TF_2INT, 2, 2 )
makenode( DIVIDE, "!0t/!1t", TF_2INT, 2, 2 )
makenode( MODULUS, "!0t%!1t", TF_2INT, 2, 2 )
makenode( PLUS, "!0t + !1t", TF_2INT, 2, 2 )
makenode( MINUS, "!0t - !1t", TF_2INT, 2, 2 )
makenode( LT, "!0t < !1t", TF_2INT|TF_RETINT, 2, 2 )
makenode( GT, "!0t > !1t", TF_2INT|TF_RETINT, 2, 2 )
makenode( LE, "!0t <= !1t", TF_2INT|TF_RETINT, 2, 2 )
makenode( GE, "!0t >= !1t", TF_2INT|TF_RETINT, 2, 2 )
makenode( EQ, "", TF_RETINT, 2, 2 )
makenode( NE, "", TF_RETINT, 2, 2 )
makenode( IN, "", TF_RETINT, 2, 2 )
makenode( NOT_IN, "", TF_RETINT, 2, 2 )
makenode( HAS, "", TF_RETINT, 2, 2 )
makenode( NOT_HAS, "", TF_RETINT, 2, 2 )
makenode( BAND, "!0t & !1t", TF_2INT, 2, 2 )
makenode( BOR, "!0t | !1t", TF_2INT, 2, 2 )
makenode( AND, "!0t && !1t", TF_2INT|TF_RETINT, 2, 2 )
makenode( XOR, "!0t ^ !1t", TF_2INT, 2, 2 )
makenode( OR, "!0t || !1t", TF_2INT|TF_RETINT, 2, 2 )
makenode( QUERY, "!0t ? !1t : !2t", 0, 3, 3 )
makenode( PATTERN, "!0P", 0, 0, 1 )
makenode( PARSE, "", 0, 3, 3 )
makenode( ARINIT, "", 0, 2, 2 )

divert(9)
/* any extra defines */
divert(1)
 };
